//+------------------------------------------------------------------+
//|                                          FX Sniper's T3 MACD.mq4 |
//|                                       Original Code by FX Sniper |
//|                                  Copyright  2007, Forex-TSD.com |
//|                                              Written by Linuxser |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Forex-TSD.com "
#property link      "http://www.forex-tsd.com/"

#property  indicator_separate_window
#property  indicator_buffers 5
#property  indicator_color1  YellowGreen
#property  indicator_color2  Tomato
#property  indicator_color3  DodgerBlue
#property  indicator_color4  Red
#property  indicator_color5  Blue
#property  indicator_level1  0
#property  indicator_levelcolor  Gray
#property  indicator_levelstyle 0
//----
extern int FastMA=12;
extern int SlowMA=26;
extern int SignalEMA=9;
extern int Applied_Price  =  0; // 0: Close // 1: Open // 2: High // 3: Low // 4: Median (H+L/2) // 5: Typical (H+L+C/3) // 6: Weighted (H+L+C+C/4)
extern int T3_Period = 5;
extern double b = 0.618;
extern int Style  = 0; 

//----
double e1, e2, e3, e4, e5, e6;
double e1a, e2a, e3a, e4a, e5a, e6a;
double c1, c2, c3, c4;
double c1a, c2a, c3a, c4a;
double n, w1, w2, b2, b3;
double na, w1a, w2a, b2a, b3a;
double MACD[];
double MACDHup[];
double MACDHdn[];
double MACD_Signal[];
double MACD_Histogram[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators setting
    SetIndexBuffer(4, MACD);
    SetIndexBuffer(0, MACDHup);
    SetIndexBuffer(1, MACDHdn);
    SetIndexBuffer(3, MACD_Signal);
    SetIndexBuffer(2, MACD_Histogram);
//----
    SetIndexStyle(0, DRAW_NONE);
    SetIndexStyle(1, DRAW_NONE);
    SetIndexStyle(2, DRAW_HISTOGRAM); 
    SetIndexStyle(3, DRAW_LINE);
    SetIndexStyle(4, DRAW_LINE);
    
//----        
    IndicatorShortName("MACD T3("+FastMA+","+SlowMA+","+SignalEMA+", " + T3_Period + ")");
    SetIndexLabel(0, "MACD");     
    SetIndexLabel(1, NULL);
    SetIndexLabel(2, NULL);
    SetIndexLabel(3, "Signal");
    SetIndexLabel(4, "Histogram");   
//---- variable reset
    b2 = b*b;
    b3 = b2*b;
    c1 = -b3;
    c2 = (3*(b2 + b3));
    c3 = -3*(2*b2 + b + b3);
    c4 = (1 + 3*b + b3 + 3*b2);
    n = T3_Period;
//----
    if(n < 1) 
        n = 1;
    n = 1 + 0.5*(n - 1);
    w1 = 2 / (n + 1);
    w2 = 1 - w1;
    
//----
    return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int counted_bars = IndicatorCounted();
//---- check for possible errors
   if(counted_bars < 0) 
       return(-1);
//---- last counted bar will be recounted
   if(counted_bars > 0) 
       counted_bars--;
   limit = Bars - counted_bars;  
//---- indicator calculation
   for(int i = Bars - 1; i >= 0; i--)
     {   
       MACD[i] = iMACD(NULL, 0, FastMA,SlowMA,SignalEMA, Applied_Price,MODE_MAIN, i);       
       e1 = w1*MACD[i] + w2*e1;
       e2 = w1*e1 + w2*e2;
       e3 = w1*e2 + w2*e3;
       e4 = w1*e3 + w2*e4;
       e5 = w1*e4 + w2*e5;
       e6 = w1*e5 + w2*e6;    
       MACD[i] = c1*e6 + c2*e5 + c3*e4 + c4*e3;    
     }
     for(i = Bars - 1 ; i >= 0; i--)
     {    
       MACD_Signal[i] = iMACD(NULL, 0, FastMA,SlowMA,SignalEMA,Applied_Price,MODE_SIGNAL, i);
       e1 = w1*MACD_Signal[i] + w2*e1;
       e2 = w1*e1 + w2*e2;
       e3 = w1*e2 + w2*e3;
       e4 = w1*e3 + w2*e4;
       e5 = w1*e4 + w2*e5;
       e6 = w1*e5 + w2*e6;    
       MACD_Signal[i] = c1*e6 + c2*e5 + c3*e4 + c4*e3;  
      }   
     for(i = Bars - 1 ; i >= 0; i--)
     {    
       MACD_Histogram[i]=MACD[i]-MACD_Signal[i]; 
     
     //----
       if(MACD[i] >= 0)
           MACDHup[i] = MACD[i];
       else
           MACDHup[i] = 0;   
       //----
       if(MACD[i] < 0 )
           MACDHdn[i] = MACD[i];
       else
           MACDHdn[i] = 0; 
      }   

     if(Style == 1)
      {
         for(i=0; i<limit; i++)
         {
               SetIndexStyle(0,DRAW_HISTOGRAM);
               SetIndexStyle(1,DRAW_HISTOGRAM);             
         } 
         } 
      if(Style == 2)
      {
         for(i=0; i<limit; i++)
         {
               SetIndexStyle(0,DRAW_HISTOGRAM);
               SetIndexStyle(1,DRAW_HISTOGRAM);
               SetIndexStyle(2,DRAW_NONE);             
         } 
         } 
      if(Style == 3)
      {
         for(i=0; i<limit; i++)
         {
               SetIndexStyle(2,DRAW_NONE);             
         } 
         } 
             
//----
   return(0);
  }
//+------------------------------------------------------------------+